/*
profstop.c

Stop profiling.

Created:	Aug 15, 1992 by Philip Homburg
*/

#include <sys/types.h>
#include <sys/ioctl.h>
#include <errno.h>
#include <fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define PROFILE_DEV	"/dev/profile"

char *prog_name;

void main _ARGS(( int argc, char *argv[] ));

void main(argc, argv)
int argc;
char *argv[];
{
	int fd, r;

	prog_name= argv[0];
	
	fd= open(PROFILE_DEV, O_RDWR);
	if (fd == -1)
	{
		fprintf(stderr, "%s: unable to open '%s': %s\n", prog_name,
			PROFILE_DEV, strerror(errno));
		exit(1);
	}
	r= ioctl(fd, PIOCSTOP, NULL);
	if (r == -1)
	{
		fprintf(stderr, "%s: unable to stop profiling\n", prog_name);
		exit(1);
	}
	exit(0);
}
